﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Threading;
using Telerik.Windows.Data;

namespace WpfApplication1
{
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            DataContext = new MyDataContext();
            
        }
    }

    public class MyDataContext
    {
        ObservableCollection<MyObject> _Property1;
        public ObservableCollection<MyObject> Property1
        {
            get
            {
                if (_Property1 == null)
                {
                    _Property1 = new ObservableCollection<MyObject>(from i in Enumerable.Range(0, 10) select new MyObject() { ID = i, Name = String.Format("Name{0}", i) });

                    var rnd = new Random();

                    var timer = new DispatcherTimer();
                    timer.Interval = TimeSpan.FromMilliseconds(1);
                    timer.Tick += (s, e) => 
                    {
                        var value = rnd.Next(_Property1.Count - 1);

                        _Property1[value].ID = rnd.Next(int.MaxValue);
                        _Property1[value].Name = String.Format("Name{0}", rnd.Next(int.MaxValue));
                    };
                    timer.Start();
                }

                return _Property1;
            }
        }

        ObservableItemCollection<MyObject2> _Property2;
        public ObservableItemCollection<MyObject2> Property2
        {
            get
            {
                if (_Property2 == null)
                {
                    _Property2 = new ObservableItemCollection<MyObject2>();
                    _Property2.AddRange(from i in Enumerable.Range(0, 10) select new MyObject2() { ID = i, Name = String.Format("Name{0}", i) });
                    
                    var rnd = new Random();

                    var timer = new DispatcherTimer();
                    timer.Interval = TimeSpan.FromMilliseconds(1);
                    timer.Tick += (s, e) =>
                    {
                        var value = rnd.Next(_Property2.Count - 1);

                        _Property2[value].ID = rnd.Next(int.MaxValue);
                        _Property2[value].Name = String.Format("Name{0}", rnd.Next(int.MaxValue));

                        Property2.Reset();

                    };
                    timer.Start();
                }

                return _Property2;
            }
        }
    }

    public class MyObject
    {
        public int ID { get; set; }
        public string Name { get; set; }
    }

    public class MyObject2 : INotifyPropertyChanged
    {
        int _ID;
        public int ID { get { return _ID; } set { if (_ID != value) { _ID = value; OnPropertyChanged("ID"); } } }

        string _Name;
        public string Name { get { return _Name; } set { if (_Name != value) { _Name = value; OnPropertyChanged("Name"); } } }

        #region INotifyPropertyChanged Members

        private void OnPropertyChanged(string propertyName)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }
}
